# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, Optional
from pydantic.v1 import BaseModel, Field, StrictStr, ValidationError, validator
from finbourne_candela.models.i_enum import IEnum
from finbourne_candela.models.i_str import IStr
from typing import Union, Any, List, TYPE_CHECKING
from pydantic.v1 import StrictStr, Field

KEYS_ANY_OF_SCHEMAS = ["IEnum", "IStr", "object"]

class Keys(BaseModel):
    """
    Keys
    """

    # data type: IStr
    anyof_schema_1_validator: Optional[IStr] = None
    # data type: IEnum
    anyof_schema_2_validator: Optional[IEnum] = None
    # data type: object
    anyof_schema_3_validator: Optional[Any] = None
    if TYPE_CHECKING:
        actual_instance: Union[IEnum, IStr, object]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(KEYS_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = Keys.construct()
        error_messages = []
        # validate data type: IStr
        if not isinstance(v, IStr):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IStr`")
        else:
            return v

        # validate data type: IEnum
        if not isinstance(v, IEnum):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IEnum`")
        else:
            return v

        # validate data type: object
        try:
            instance.anyof_schema_3_validator = v
            return v
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in Keys with anyOf schemas: IEnum, IStr, object. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Keys:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Keys:
        """Returns the object represented by the json string"""
        instance = Keys.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[IStr] = None
        try:
            instance.actual_instance = IStr.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[IEnum] = None
        try:
            instance.actual_instance = IEnum.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # deserialize data into object
        try:
            # validation
            instance.anyof_schema_3_validator = json.loads(json_str)
            # assign value to actual_instance
            instance.actual_instance = instance.anyof_schema_3_validator
            return instance
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Keys with anyOf schemas: IEnum, IStr, object. Details: " + ", ".join(error_messages))
        else:
            return instance

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            return json.dumps(self.actual_instance)
