# coding: utf-8

"""
    FINBOURNE Candela Platform Web API

    FINBOURNE Technology  # noqa: E501

    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic.v1 import BaseModel, Field, StrictStr, ValidationError, validator
from finbourne_candela.models.confirm import Confirm
from finbourne_candela.models.insert_context import InsertContext
from finbourne_candela.models.intent import Intent
from finbourne_candela.models.no_op import NoOp
from finbourne_candela.models.response import Response
from finbourne_candela.models.switch import Switch
from finbourne_candela.models.use_tool import UseTool
from typing import Union, Any, List, TYPE_CHECKING
from pydantic.v1 import StrictStr, Field

NODES_ANY_OF_SCHEMAS = ["Confirm", "InsertContext", "Intent", "NoOp", "Response", "Switch", "UseTool"]

class Nodes(BaseModel):
    """
    Nodes
    """

    # data type: Response
    anyof_schema_1_validator: Optional[Response] = None
    # data type: Intent
    anyof_schema_2_validator: Optional[Intent] = None
    # data type: Confirm
    anyof_schema_3_validator: Optional[Confirm] = None
    # data type: UseTool
    anyof_schema_4_validator: Optional[UseTool] = None
    # data type: Switch
    anyof_schema_5_validator: Optional[Switch] = None
    # data type: InsertContext
    anyof_schema_6_validator: Optional[InsertContext] = None
    # data type: NoOp
    anyof_schema_7_validator: Optional[NoOp] = None
    if TYPE_CHECKING:
        actual_instance: Union[Confirm, InsertContext, Intent, NoOp, Response, Switch, UseTool]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(NODES_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = Nodes.construct()
        error_messages = []
        # validate data type: Response
        if not isinstance(v, Response):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Response`")
        else:
            return v

        # validate data type: Intent
        if not isinstance(v, Intent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Intent`")
        else:
            return v

        # validate data type: Confirm
        if not isinstance(v, Confirm):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Confirm`")
        else:
            return v

        # validate data type: UseTool
        if not isinstance(v, UseTool):
            error_messages.append(f"Error! Input type `{type(v)}` is not `UseTool`")
        else:
            return v

        # validate data type: Switch
        if not isinstance(v, Switch):
            error_messages.append(f"Error! Input type `{type(v)}` is not `Switch`")
        else:
            return v

        # validate data type: InsertContext
        if not isinstance(v, InsertContext):
            error_messages.append(f"Error! Input type `{type(v)}` is not `InsertContext`")
        else:
            return v

        # validate data type: NoOp
        if not isinstance(v, NoOp):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NoOp`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in Nodes with anyOf schemas: Confirm, InsertContext, Intent, NoOp, Response, Switch, UseTool. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> Nodes:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Nodes:
        """Returns the object represented by the json string"""
        instance = Nodes.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[Response] = None
        try:
            instance.actual_instance = Response.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[Intent] = None
        try:
            instance.actual_instance = Intent.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[Confirm] = None
        try:
            instance.actual_instance = Confirm.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_4_validator: Optional[UseTool] = None
        try:
            instance.actual_instance = UseTool.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_5_validator: Optional[Switch] = None
        try:
            instance.actual_instance = Switch.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_6_validator: Optional[InsertContext] = None
        try:
            instance.actual_instance = InsertContext.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_7_validator: Optional[NoOp] = None
        try:
            instance.actual_instance = NoOp.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into Nodes with anyOf schemas: Confirm, InsertContext, Intent, NoOp, Response, Switch, UseTool. Details: " + ", ".join(error_messages))
        else:
            return instance

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            return json.dumps(self.actual_instance)
